<i18n>
{
  "fr": {
    "label-1": "Catégorie d'achat",
    "label-2": "Part de l'empreinte achat"
  },
  "en": {
    "label-1": "Purchase category ",
    "label-2": "Share of the purchase footprint"
  }
}
</i18n>

<template>
  <div>
    <highcharts :options="options"></highcharts>
    <br />
    <b-table
      :striped="true"
      :narrowed="true"
      :hoverable="true"
      :data="dataPerCategories"
    >
      <b-table-column field="category" :label="$t('label-1')" v-slot="props">
        {{ props.row.category }}
      </b-table-column>
      <b-table-column field="intensity" numeric :label="$t('emissions.t.co2e.short')" v-slot="props">
        {{ Math.round(props.row.intensity) | splitNumberTons }} &plusmn; {{ Math.round(props.row.uncertainty) | splitNumberTons }}
      </b-table-column>
      <b-table-column numeric :label="$t('label-2')" v-slot="props">
        {{ Math.round(props.row.intensity / results.intensity.intensity * 100 ) }} %
      </b-table-column>
    </b-table>
  </div>
</template>

<script>
import '@/plugins/highcharts.js'

export default {
  name: 'PlotsPurchases',
  data () {
    const component = this
    return {
      options: {
        chart: {
          type: 'pie'
        },
        title: {
          verticalAlign: 'middle',
          floating: true,
          text: ''
        },
        plotOptions: {
          pie: {
            innerSize: '60%',
            allowPointSelect: true,
            cursor: 'pointer',
            dataLabels: {
              enabled: true,
              formatter () {
                return (
                  `<b>${this.point.name}:</b> ${component.$options.filters.splitNumberTons(this.y)} ${component.$t('t.co2e')}`
                )
              }
            },
            showInLegend: true
          }
        },
        credits: {
          enabled: false
        },
        legend: {
          enabled: false
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        series: [{
          name: this.$t('carbon.footprint'),
          colorByPoint: true,
          data: []
        }],
        tooltip: {
          pointFormatter () {
            return (
              `<b>${component.$options.filters.splitNumberTons(this.y)} ${component.$t('t.co2e')}</b>`
            )
          }
        }
      }
    }
  },
  computed: {
    results: function () {
      return this.$store.getters['purchases/results']
    },
    dataPerCategories: function () {
      let dataPerCategories = []
      for (let category in this.results.categories) {
        dataPerCategories.push({
          'category': this.$t(category),
          'intensity': this.results.categories[category].intensity,
          'uncertainty': this.results.categories[category].uncertainty
        })
      }
      return dataPerCategories
    }
  },
  methods: {
    process: function () {
      if (this.$store.getters['purchases/computed']) {
        for (let category in this.results.categories) {
          this.options.series[0].data.push({
            name: this.$t(category),
            y: Math.round(this.results.categories[category].intensity)
          })
        }
      }
    }
  },
  mounted () {
    if (!this.$store.getters['purchases/computed']) {
      this.$store.dispatch('purchases/compute')
    }
    this.process()
    this.options.title.text = '<strong>' + this.$options.filters.splitNumberTons(Math.round(this.results.intensity.intensity)) + ' ' + this.$t('t.co2e') + ' </strong>'
  }
}
</script>

<style>
.table td {
  vertical-align: middle !important;
}
</style>
